#include <windows.h>
#include <tchar.h>
#include "resource.h"

#define DRIVER_PATH _TEXT("C:\\beeptest.sys")
#define DRIVER_NAME _TEXT("beeptest")

// _CAO{bNXvV[W[
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

//	hCoCXg[
BOOL adddrv(TCHAR* DriverId, TCHAR* DriverPath);

//	hCoACXg[
BOOL deldrv(TCHAR* DriverId, TCHAR* DriverPath);

// Ǎt@C̎擾
BOOL GetFileName(HWND hWnd, TCHAR* fname, int sz);

//	G[R[hG[bZ[W쐬_CAO{bNXɕ\
void error_dialog(HWND hWnd, int errorcode);

HWND hDlg;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst, TCHAR* lpszCmdLine, int nCmdShow){
	DialogBox(hInstance, TEXT("DLG1"), 0, (DLGPROC)DlgProc1);
	return 0;
}

 // _CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	TCHAR driver_path[MAX_PATH];
	TCHAR driver_name[MAX_PATH];
	TCHAR* top,*bottom;
	switch (msg) {
	case WM_INITDIALOG:
		::hDlg = hDlg;
		SetWindowText(GetDlgItem(hDlg, IDC_PATH_EDIT), DRIVER_PATH);
		SetWindowText(GetDlgItem(hDlg, IDC_NAME_EDIT), DRIVER_NAME);
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_LOAD_BUTTON:
			GetWindowText(GetDlgItem(hDlg, IDC_PATH_EDIT), driver_path,sizeof(driver_path)/sizeof(TCHAR));
			GetWindowText(GetDlgItem(hDlg, IDC_NAME_EDIT), driver_name, sizeof(driver_name) / sizeof(TCHAR));
			if (adddrv(driver_name, driver_path) == TRUE)
				MessageBox(hDlg, _TEXT("hCo[CXg[܂"), _TEXT(""), MB_OK);
			else
				MessageBox(hDlg, _TEXT("hCo[CXg[ł܂ł"), _TEXT("G["), MB_OK);
			return TRUE;
		case IDC_UNLOAD_BUTTON:
			GetWindowText(GetDlgItem(hDlg, IDC_PATH_EDIT), driver_path, sizeof(driver_path) / sizeof(TCHAR));
			GetWindowText(GetDlgItem(hDlg, IDC_NAME_EDIT), driver_name, sizeof(driver_name) / sizeof(TCHAR));
			if(deldrv(driver_name, driver_path)==TRUE)
				MessageBox(hDlg, _TEXT("hCo[ACXg[܂"), _TEXT(""), MB_OK);
			else
				MessageBox(hDlg, _TEXT("hCo[ACXg[ł܂ł"), _TEXT("G["), MB_OK);
				return TRUE;
		case IDC_REF_BUTTON:
			if (GetFileName(hDlg, driver_path, sizeof(driver_path) / sizeof(TCHAR))){
				top = _tcsrchr(driver_path, _T('\\'));
				bottom = _tcsrchr(driver_path, _T('.'));
				if (_tcscmp(bottom + 1, _TEXT("sys")) == 0){	//	gq`FbN
					if (top < bottom){
						_tcsncpy_s(driver_name, sizeof(driver_name) / sizeof(TCHAR), top + 1, bottom - top - 1);
					}
				}
				SetWindowText(GetDlgItem(hDlg, IDC_PATH_EDIT), driver_path);
				SetWindowText(GetDlgItem(hDlg, IDC_NAME_EDIT), driver_name);
			}
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return FALSE;
		default:
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

//	hCoCXg[

BOOL adddrv(TCHAR* DriverId, TCHAR* DriverPath){
	SC_HANDLE hSCManager;
	SC_HANDLE hService;

	// T[rXRg[}l[W[J
	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (hSCManager == NULL){
		DWORD dwError = GetLastError();
		error_dialog(hDlg, dwError);
		return FALSE;	//	T[rXRg[}l[WF[JȂ
	}
	hService = OpenService(hSCManager, DriverId, SERVICE_ALL_ACCESS);
	if (hService == 0){
		//	hCoT[rX𐶐
		hService = CreateService(hSCManager, DriverId, DriverId,
			SERVICE_ALL_ACCESS,
			SERVICE_KERNEL_DRIVER,
			SERVICE_DEMAND_START,
			SERVICE_ERROR_NORMAL,
			DriverPath,
			NULL, NULL, NULL, NULL, NULL);
		if (hService == NULL){
			DWORD dwError = GetLastError();
			error_dialog(hDlg, dwError);
			CloseServiceHandle(hSCManager);
			return FALSE;
		}
	}

	if (StartService(hService, 0, NULL) == FALSE){
		DWORD dwError = GetLastError();
		//T[rX̃CX^X͂łɓ삵ĂȊÕG[
		if (dwError != ERROR_SERVICE_ALREADY_RUNNING){
			error_dialog(hDlg, dwError);
			DeleteService(hService);
			CloseServiceHandle(hService);
			CloseServiceHandle(hSCManager);
			return FALSE;
		}
	}

	CloseServiceHandle(hService);
	CloseServiceHandle(hSCManager);
	return TRUE;
}

//	hCoACXg[

BOOL deldrv(TCHAR* DriverId, TCHAR* DriverPath){
	SC_HANDLE hSCManager;
	SC_HANDLE	hService;
	// T[rXRg[}l[W[J
	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (hSCManager == NULL){
		DWORD dwError = GetLastError();
		error_dialog(hDlg, dwError);
		return FALSE;	//	T[rXRg[}l[WF[JȂ
	}
	hService = OpenService(hSCManager, DriverId, SERVICE_ALL_ACCESS);
	if (hService == 0){
		DWORD dwError = GetLastError();
		error_dialog(hDlg, dwError);
		CloseServiceHandle(hSCManager);
		return FALSE;
	}
	SERVICE_STATUS status;
	ControlService(hService, SERVICE_CONTROL_STOP, &status);
	DeleteService(hService);

	CloseServiceHandle(hService);
	CloseServiceHandle(hSCManager);
	return TRUE;
}


// Ǎt@C̎擾

BOOL GetFileName(HWND hWnd,TCHAR* fname, int sz){
	OPENFILENAME o;
	fname[0] = _T('\0');
	ZeroMemory(&o, sizeof(o));
	o.lStructSize = sizeof(o);
	o.hwndOwner = hWnd;
	o.Flags = 0;
	o.lpstrFile = fname;
	o.nMaxFile = sz;
	o.lpstrFilter = _TEXT("SYS(*.SYS)\0");
	o.nFilterIndex = 1;
	return GetOpenFileName(&o);
}

//	G[R[hG[bZ[W쐬_CAO{bNXɕ\

void error_dialog(HWND hWnd, int errorcode){
	LPVOID lpMsgBuf;
	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL, errorcode, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR)&lpMsgBuf, 0, NULL);

	MessageBox(hWnd, (LPCTSTR)lpMsgBuf, _TEXT("G["), MB_OK | MB_ICONINFORMATION);
	LocalFree(lpMsgBuf);
}
